import component
import pygame
from pygame.locals import *

BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)

class BuildInfo(component.Component):
    def __init__(self, screen, left, top, ipm):
        self.screen = screen
        self.top = top
        self.left = left
        self.width = 80
        self.height = 25
        self.smallFont = pygame.font.SysFont(None, 20)
        self.ipm = ipm
        print "build time init"
        try:
            if self.ipm != None:
                self.ipm.eval_string("import build")
                self.revision = self.ipm.eval_string("build.revision")
                self.robotid = self.ipm.eval_string("rone.get_id()")
                self.revision = str(self.revision.rstrip())
                self.robotid = str(self.robotid.rstrip())
            else:
                self.revision = "N/A"
                self.robotid = "N/A"
        except:
            self.revision = "N/A"
            self.robotid = "N/A"

        self.robotlabel_rect = pygame.rect.Rect(self.left, self.top, self.width, self.height)
        self.revisionlabel_rect = pygame.rect.Rect(self.left, self.top + self.height, self.width, self.height)
        self.robot_rect = pygame.rect.Rect(self.left + self.width , self.top, self.width, self.height)
        self.revision_rect = pygame.rect.Rect(self.left+self.width, self.top+self.height, self.width, self.height)
        
        

    def draw(self):
        pygame.draw.rect(self.screen, WHITE, self.revisionlabel_rect)
        self.screen.blit(self.smallFont.render("Revision: ", True, BLACK, WHITE), self.revisionlabel_rect)
        self.screen.blit(self.smallFont.render("RobotID: ", True, BLACK, WHITE), self.robotlabel_rect)
        self.screen.blit(self.smallFont.render(self.revision, True, BLACK, WHITE), self.revision_rect)
        self.screen.blit(self.smallFont.render(self.robotid, True, BLACK, WHITE), self.robot_rect)


        
