import component
import pygame
from pygame.locals import *
import sys
import math



BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)
DARKGREY = (84, 84, 94)


class Gyro(component.Component):
    def __init__(self, screen, left, top, diameter, start, end, ipm):
        self.smallFont = pygame.font.SysFont(None, 20)
        self.screen = screen
        self.left = left
        self.top = top
        self.diameter = diameter
        self.radius = self.diameter/2


        self.max = 1023
        self.max_calibrated = 1023  -  416
        
        self.start = start
    
        self.end = end
        self.color = DARKGREY
        self.fill_rect = pygame.rect.Rect(self.left, self.top, self.diameter, self.diameter)
        self.text_rect = pygame.rect.Rect(self.left+self.radius-20, self.top+self.radius-20, 40, 40)
        self.gyro_knob = (self.left + self.radius, self.top) 
        self.gyro_num = "0"
        self.ipm = ipm
    def draw(self):
        pygame.draw.circle(self.screen, WHITE, self.gyro_knob, 6, 0)
        self.knob()
        pygame.draw.arc(self.screen, DARKGREY, self.fill_rect, 0, math.pi, 2)
        pygame.draw.circle(self.screen, RED, self.gyro_knob, 6, 0)
        pygame.draw.rect(self.screen, WHITE, self.text_rect)
        self.screen.blit(self.smallFont.render(self.gyro_num.rstrip(), True, BLACK, WHITE), self.text_rect)
##    def timer(self):
##        if self.ipm != None:
##            uncalibrated = int(self.ipm.eval_string("rone.gyro_get_value()"))
##            self.gyro_num = str( uncalibrated  - 416 )

 
    def knob(self):
        gyro_deg = ((float(self.gyro_num) / self.max_calibrated) * 90) + 90#
        y = -(self.radius * (math.sin(gyro_deg))) + self.top + self.radius
        x = -(self.radius * (math.cos(gyro_deg))) + self.left + self.radius
    
        self.gyro_knob = (int(x), int(y))
        
        
