import component
import pygame
from pygame.locals import *

BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)
DARKGREY = (84, 84, 94)
AMBER = (255, 97, 3)


class IRBeacon(component.Component):
    def __init__(self, screen, center, radius, idnum, ipm):
        self.screen = screen
        self.center = center
        self.radius = radius
        self.idnum = idnum
        self.color = DARKGREY
        self.color_on = AMBER
        self.color_off = DARKGREY
        self.ipm = ipm

    def draw(self):
        pygame.draw.circle(self.screen, self.color, self.center, self.radius, 0)
        if self.ipm != None and self.color == self.color_on:
            self.ipm.eval_string("rone.ir_beacon_set_data(" + str(self.idnum) + ")")

        
    def mouse_click(self, eventpos):
        i, j = self.center
        x, y = eventpos
        if (i - self.radius) < x < (i + self.radius) and (j - self.radius)<y<(j+self.radius):
            if self.color == self.color_off:
                self.color = self.color_on
                if self.ipm != None:
                    self.ipm.eval_string("rone.ir_beacon_set_data(" + str(self.idnum) + ")")
            elif self.color == self.color_on:
                self.color = self.color_off
                    
##                    
##    def mouse_up(self):
##        self.color = self.color_off                    
