import component
import pygame
from pygame.locals import *
import sys

BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)
DARKGREY = (84, 84, 94)


INIT_CODES = [r"""
def update_ir():
    global last_msg
    last_msg = rone.ir_comms_get_message()
""", r"""
def gui_ir(loc):
    global last_msg
    (msg, locs) = last_msg
    if loc in locs:
        return msg
    else:
        return ""
"""]


class IRreceiver(component.Component):
    def __init__(self, screen, left, top, width, label, label_width, ipm, define=False):
        self.screen = screen
        self.left = left
        self.top = top
        self.width = width
        self.height = 20
        self.label = label
        self.label_width = label_width
        self.text = "N/A"
        self.smallFont = pygame.font.SysFont(None, 20)
        self.text_rect = pygame.rect.Rect(self.left + self.label_width, self.top, self.width, self.height)
        self.label_rect = pygame.rect.Rect(self.left, self.top, self.label_width, self.height)
        
        self.ipm = ipm

        if define:
            for code in INIT_CODES:
                self.ipm.eval_string(code)

    def update_ir(self):
        self.ipm.eval_string('update_ir()')

    def timer(self):
        if self.ipm != None:
            call = "gui_ir(" + str(self.label) + ")"
            self.text = self.ipm.eval_string(call).strip()
        
        pygame.draw.rect(self.screen, BLACK, self.text_rect)
        pygame.draw.rect(self.screen, BLACK, self.label_rect)
        self.screen.blit(self.smallFont.render(self.text.rstrip(), True, WHITE), self.text_rect)
        self.screen.blit(self.smallFont.render(str(self.label), True, WHITE), self.label_rect)
