import pygame
from pygame.locals import *



ipm = robot.init_ipm("com4")
ipm.eval_string("import mr1")
ipm.eval_string("mr1.enable_motor('l')")
ipm.eval_string("mr1.enable_motor('r')")

pygame.init()

pygame.joystick.init()

j = pygame.joystick.Joystick(0)
j.init()


def motorRun(i, j):
    x = normalize(i)
    y = normalize(j)
    if i == 0 and j ==0:
        ipm.eval_string("mr1.run_motor('l', 'f', 0)")
        ipm.eval_string("mr1.run_motor('r', 'f', 0)")
    if -0.46 < i < 0.46 and j != 0: #or (-.42 < i < -.18 and j != 0) :
        translateral(y)

    else:
        rotational(x, y)
    

def normalize(num):
    if .35 <  abs(num) < .50:
        if num > 0:
            return .45
        else:
            return .45
    if abs(num) > .95:
        if num >0:
            return .95
        else:
            return -.95
    else:
        return num

def translateral(y):
    if y<0:
        ipm.eval_string("mr1.run_motor('l', 'f', " + str(abs(y)*100) + ")")
        ipm.eval_string("mr1.run_motor('r', 'f', " + str(abs(y)*100) + ")")
    else:
        ipm.eval_string("mr1.run_motor('l', 'r', " + str(abs(y)*100) + ")")
        ipm.eval_string("mr1.run_motor('r', 'r', " + str(abs(y)*100) + ")")


def rotational(x, y):
    prev_l = 0
    prev_r = 0
    if x<=0 and y<=0:
        left = prev_l + x
        right = prev_r - x
        prev_l = left
        prev_r = right
        ipm.eval_string("mr1.run_motor('l', 'f', " + str(abs(left)*100) + ")")
        ipm.eval_string("mr1.run_motor('r', 'r', " + str(abs(right)*100) + ")")
        print prev_l, prev_r, left, right
    
    if x>=0 and y<=0:
        left = prev_l + x
        right = prev_r - x
        prev_l = left
        prev_r = right
        ipm.eval_string("mr1.run_motor('l', 'r', " + str(abs(left)*100) + ")")
        ipm.eval_string("mr1.run_motor('r', 'f', " + str((abs(right)*100)) + ")")
        print prev_l, prev_r, left, right
    if x<=0 and y>=0:
        left = prev_l - x
        right = prev_r + x
        prev_l = left
        prev_r = right
        ipm.eval_string("mr1.run_motor('l', 'r', " + str(abs(left)*100) + ")")
        ipm.eval_string("mr1.run_motor('r', 'f', " + str(abs(right)*100) + ")")
        print prev_l, prev_r, left, right
    if x>=0 and y>=0:
        left = prev_l - x
        right = prev_r + x
        prev_l = left
        prev_r = right
        ipm.eval_string("mr1.run_motor('l', 'f', " + str(abs(left)*100) + ")")
        ipm.eval_string("mr1.run_motor('r', 'r', " + str(abs(right)*100) + ")")
        print prev_l, prev_r, left, right


print 'Enabled joystick: ' + j.get_name()
while 1:
    for e in pygame.event.get(): # iterate over event stack
        print 'event : ' + str(e.type)
        if e.type == pygame.locals.JOYAXISMOTION: # 7
            x , y = j.get_axis(0), j.get_axis(1)
            print 'x and y : ' + str(x) +' , '+ str(y)
            
            motorRun(x, y)
        elif e.type == pygame.locals.JOYBALLMOTION: # 8
            print 'ball motion'
        elif e.type == pygame.locals.JOYHATMOTION: # 9
            print 'hat motion'
        elif e.type == pygame.locals.JOYBUTTONDOWN: # 10
            print 'button down'
        elif e.type == pygame.locals.JOYBUTTONUP: # 11
            print 'button up'
        
