import component
import pygame
from pygame.locals import *
import sys
import time

BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)
DARKGREY = (84, 84, 94)

class LED(component.Component):
    def __init__(self, screen, center, radius, color_on, led_color, brightness, ipm):
        self.screen = screen
        self.center = center
        self.color = DARKGREY
        self.color_on = color_on
        self.color_off = DARKGREY
        self.led_color = led_color
        self.brightness = brightness
        self.radius = radius
        self.ipm = ipm
        #if self.ipm != None: #turns off IR beacon emitter   
        #    self.ipm.eval_string("rone.led_set(15, 0)")
            

    def draw(self):
        pygame.draw.circle(self.screen, self.color, self.center, self.radius, 0) 
        pygame.draw.circle(self.screen, GREY, self.center, (self.radius - 8), 0)
        
    def mouse_click(self, eventpos):
        i, j = self.center
        x, y = eventpos
        if (i - self.radius)<x<(i + self.radius) and (j - self.radius)<y<(j+self.radius):
            if self.color == self.color_off:
                self.color = self.color_on
                self.draw()
                if self.ipm != None:
                    self.ipm.eval_string("rone.led_set_group('" + self.led_color + "', " + str(self.brightness) + ")")
            else:
                self.color = self.color_off
                if self.ipm != None:
                    self.ipm.eval_string("rone.led_set_group('" + self.led_color + "', 0)")

class LEDButton(component.Component):
    def __init__(self, screen, center, radius, color_on, pin_str, ipm):
        
        self.screen = screen
        self.center = center
        self.radius = radius
        self.color = DARKGREY
        self.color_on = color_on
        self.color_off = DARKGREY
        self.ipm = ipm
        self.pin_str = pin_str
        self.push_state = 0

    def draw(self):
        self.set_color()
        pygame.draw.circle(self.screen, self.color, self.center, (self.radius), 0)
    def pushed(self):
        if self.ipm != None:
            self.push_state = self.ipm.eval_string('rone.button_get_value("' + self.pin_str + '")') #returns 0 when pushed, 1 when not
    def set_color(self):
        if int(self.push_state) == 1:
            self.color = self.color_on
        else: self.color = self.color_off
    def timer(self):
        self.pushed()


            
            
            
        
        
        
