import component
import pygame
from pygame.locals import *
import sys

BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)

class LightSensor(component.Component):
    def __init__(self, screen, left, top, light_str, ipm):
        self.ipm = ipm
        self.smallFont = pygame.font.SysFont(None, 20)

        self.screen = screen
        self.light_str = light_str
        self.top = top
        self.left = left
        self.text_width = 50
        self.text_height = 14
        self.width = 10
        self.height = 100
        self.label_rect = pygame.rect.Rect(self.left+10, self.top, self.text_width, self.text_height)
        self.text_rect = pygame.rect.Rect(self.left+25, self.top, self.text_width, self.text_height)
        self.bar_rect = pygame.rect.Rect(self.left, self.top, self.width, self.height)
        
        self.val_num = 0
        self.max_val = 1023

    def lightVal(self, light):
        if self.ipm != None:

            val_num = self.ipm.eval_string('rone.light_sensor_get_value("' + light + '")')
            self.val_num = int(val_num)
            if self.val_num > self.max_val:
                self.val_num = self.max_val


            percent = (float(self.val_num) / self.max_val)*100
            
            return percent
        else: return 0


    def draw(self):
        pygame.draw.rect(self.screen, WHITE, self.text_rect)
        self.screen.blit(self.smallFont.render(self.light_str, True, BLACK, WHITE), self.label_rect)
        if self.ipm != None:
            self.screen.blit(self.smallFont.render(str(self.val_num).rstrip(), True, BLACK, WHITE), self.text_rect)
        else:
            self.screen.blit(self.smallFont.render("0", True, BLACK, WHITE), self.text_rect)

    def timer(self):
        percent = self.lightVal(self.light_str)
        pygame.draw.rect(self.screen, RED, self.bar_rect)
        remainder_rect = pygame.rect.Rect(self.left, self.top, 10, (self.height - percent))
        pygame.draw.rect(self.screen, GREY, remainder_rect)
        
        


        
        
