import component
                                        
import pygame
from pygame.locals import *
import sys

BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)
DARKGREY = (84, 84, 94)

class QuadEnc(component.Component):
    def __init__(self, screen, top, left, side, ipm): #side is l or r
        
        self.ipm = ipm
        self.smallFont = pygame.font.SysFont(None, 20)

        self.screen = screen
        self.top = top
        self.left = left
        self.side = side
        self.width = 70
        self.height = 14


        
        self.position_rect = pygame.rect.Rect(self.left, (self.top + 10), self.width, self.height)
        self.pos_text_rect = pygame.rect.Rect( (self.left+75), (self.top+10), self.width, self.height)
        
        self.velocity_rect = pygame.rect.Rect( self.left, (self.top +25), self.width, self.height)
        self.vel_text_rect = pygame.rect.Rect( (self.left+75), (self.top+25), self.width, self.height)
        
        self.direction_rect = pygame.rect.Rect(self.left, (self.top+40), self.width, self.height)
        self.dir_text_rect = pygame.rect.Rect( (self.left+75), (self.top+40), self.width, self.height)

        self.left_text_pos = self.smallFont.render("N/A", True, BLACK, WHITE)
        self.left_text_vel = self.smallFont.render("N/A", True, BLACK, WHITE)
        self.left_text_dir = self.smallFont.render("N/A", True, BLACK, WHITE)

    def draw(self):

        pygame.draw.rect(self.screen, WHITE, self.pos_text_rect)
        pygame.draw.rect(self.screen, WHITE, self.vel_text_rect)
        pygame.draw.rect(self.screen, WHITE, self.dir_text_rect)

        self.screen.blit(self.smallFont.render("Position: ", True, BLACK, WHITE), self.position_rect)

        self.screen.blit(self.smallFont.render("Velocity: ", True, BLACK, WHITE), self.velocity_rect)

        self.screen.blit(self.smallFont.render("Direction: ", True, BLACK, WHITE), self.direction_rect)

        self.screen.blit(self.left_text_pos, self.pos_text_rect)
        
        self.screen.blit(self.left_text_vel, self.vel_text_rect)
        
        self.screen.blit(self.left_text_dir, self.dir_text_rect)

    def timer(self):
        self.left_text_pos = self.qe_pos()
        self.left_text_vel = self.qe_vel()
        self.left_text_dir = self.qe_dir()

        
    def qe_pos(self):
        if self.ipm != None:
            left_pos = self.ipm.eval_string('rone.encoder_get_ticks("' + self.side +'")')

            left_text_pos = self.smallFont.render(left_pos.rstrip(), True, BLACK, WHITE)
            return left_text_pos
        else:
            return self.smallFont.render("N/A", True, BLACK, WHITE)


    def qe_vel(self):
        if self.ipm != None:
            left_vel = self.ipm.eval_string('rone.encoder_get_velocity("' + self.side +'")')
            left_text_vel = self.smallFont.render(left_vel.rstrip(), True, BLACK, WHITE)
            return left_text_vel
        else:
            return self.smallFont.render("N/A", True, BLACK, WHITE)



    def qe_dir(self):
        if self.ipm != None:
            left_dir = self.ipm.eval_string('rone.encoder_get_direction("' + self.side +'")')
            left_text_dir = self.smallFont.render(left_dir.rstrip(), True, BLACK, WHITE)
            return left_text_dir
        else:
            return self.smallFont.render("N/A", True, BLACK, WHITE)


## make font preparation in a separate function
## make getting from mr1.get_ a separate function



  
        
   
