import component
import pygame
from pygame.locals import *
import sys



BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (34, 139, 34)
BLUE = (0, 0, 255)
GREY = (215, 215, 230)
DARKGREY = (84, 84, 94)

class Textbox(component.Component):
    def __init__(self, robotDisplay, screen, left, top, width, input_width, question, limit, ipm):
        self.screen = screen
        self.left = left
        self.top = top
        self.width = width
        self.height = 15
        self.input_width = input_width
        self.question = question
        self.limit = limit
        self.label_rect = pygame.rect.Rect(self.left, self.top, self.width, self.height)
        self.input_rect = pygame.rect.Rect( (self.left + self.width - 2), (self.top - 2), (self.input_width + 4), (self.height + 4))
        self.input_rect_filler = pygame.rect.Rect( (self.left + self.width ), self.top, self.input_width, self.height)
        self.clear_rect = pygame.rect.Rect( self.left, (self.top + self.height + 5), self.width, self.height)
        self.msg = []
        self.ipm = ipm
        self.robotDisplay = robotDisplay


        self.smallFont = pygame.font.SysFont(None, 20)
        self.enable = GREY
        self.enable_on = DARKGREY
        self.enable_off = GREY
        
        self.font = DARKGREY
        self.font_on = GREY
        self.font_off = DARKGREY
        self.color = GREY
        self.color_on = DARKGREY
        self.color_off = GREY
        
        self.clear = GREY
        self.clear_on = DARKGREY
        self.clear_off = GREY
        self.clear_font = DARKGREY
        self.clear_font_on = GREY
        self.clear_font_off = DARKGREY

    def draw(self):
        pygame.draw.rect(self.screen, self.color, self.label_rect)
        pygame.draw.rect(self.screen, self.clear, self.clear_rect)
        self.screen.blit(self.smallFont.render("Clear Text", True, self.clear_font), self.clear_rect)
        self.screen.blit(self.smallFont.render(self.question, True, self.font), self.label_rect) 
        pygame.draw.rect(self.screen, self.enable, self.input_rect)
        pygame.draw.rect(self.screen, WHITE, self.input_rect_filler)
        if len(self.msg) != 0:
            self.screen.blit(self.smallFont.render("".join(self.msg), True, DARKGREY), self.input_rect_filler)
        

    def typing(self, inkey):
        if self.enable == DARKGREY:
            if inkey == K_BACKSPACE:
                self.msg = self.msg[0:-1]
            else:
                if len(self.msg) == self.limit :
                    pass
                else:
                    
                    if (pygame.key.get_mods() == KMOD_RSHIFT) or (pygame.key.get_mods() == KMOD_LSHIFT) or(pygame.key.get_mods() == KMOD_CAPS) :
                        if inkey <= 127:
                            inkey = chr(inkey).upper()
                            self.msg.append(inkey)               
                    else:
                        if inkey <= 127:
                            self.msg.append(chr(inkey))

    def timer(self):
        if self.ipm != None and self.color == self.color_on:
            self.ipm.eval_string("""rone.radio_send_message('''""" + "".join(self.msg) + """''')""") 
        
                
    def mouse_click(self, eventpos):
        if self.label_rect.collidepoint(eventpos):
            if self.color == self.color_off:
                self.color = self.color_on
                self.font = self.font_on
                if self.ipm != None:
                    self.ipm.eval_string("""rone.radio_send_message('''""" + "".join(self.msg) + """''')""") 
            elif self.color == self.color_on:
                self.color = self.color_off
                self.font = self.font_off
        if self.input_rect.collidepoint(eventpos):
            if self.enable == self.enable_off:
                self.enable = self.enable_on
        if self.clear_rect.collidepoint(eventpos):
            self.clear = self.clear_on
            self.clear_font = self.clear_font_on
            self.msg = []
        if not self.input_rect.collidepoint(eventpos):
            self.enable = self.enable_off
    

##
##        if self.label_rect.collidepoint(eventpos):
##            if self.color == self.color_off:
##                self.color = self.color_on
##                self.font = self.font_on
##                if self.ipm != None:
##                    self.ipm.eval_string("""rone.radio_send_message('''""" + "".join(self.msg) + """''')""") 
##            elif self.color == self.color_on:
##                self.color = self.color_off
##                self.font = self.font_off
####            if self.question == "RF Transmit":
####                if self.ipm != None:
####                    self.ipm.eval_string("""rone.radio_send_message('''""" + "".join(self.msg) + """''')""") 
##        if self.input_rect.collidepoint(eventpos):
##            if self.enable == self.enable_off:
##                self.enable = self.enable_on
##        if self.clear_rect.collidepoint(eventpos):
##            self.clear = self.clear_on
##            self.clear_font = self.clear_font_on
##            self.msg = []
##        if not self.input_rect.collidepoint(eventpos):
##            self.enable = self.enable_off
##    

            

    def mouse_up(self):
        self.clear = self.clear_off
        self.clear_font = self.clear_font_off
        

            

